
#include <iostream>
#include <unordered_map>
#include <set>
#include "DataType.h"
#include "aneu_mesh_loader.h"


//!!! Задание на защиту (не удалять)
//!!! Выполнить на основе std::ranges
//!!! 1. Создать контейнер всех граничных КЭ (треугольников)
//!!! 2. С помощью потокового итератора вывести в файл списки ID узлов первых 10-и элементов,
//!!!    у которых значение минимального угла от 0 до 30 градусов.


int main() {
    mesh::mesh_loader *mesh_loader = new mesh::aneu_mesh_loader;
    mesh_loader->load_mesh("../extrusion.aneu");

    std::vector<mesh::node> nodes = mesh_loader->get_node();
    std::vector<mesh::finite_type> finite_elements = mesh_loader->get_finite_elems();
    std::vector<mesh::boundary_finite_element> boundaries = mesh_loader->get_boundary();


    std::vector<int> elems_by_ID = mesh_loader->get_elems_by_ID(1, 2, 3);
    std::vector<int> elems_by_material = mesh_loader->get_elems_by_material(1);
    std::vector<int> elems_by_edge = mesh_loader->get_elems_by_edge(1, 2);

    std::set<int> nodes_by_surface = mesh_loader->get_nodes_by_surface(1);

    std::vector<int> boundary_by_surface = mesh_loader->get_boundary_by_surface(2);

    mesh_loader->insert_new_nodes();

    auto adjacent_nodes = mesh_loader->get_adjacent_nodes();

    auto elem_with_min_ratio = mesh_loader->get_elems_by_min_ratio();

    delete mesh_loader;
    return 0;
}

